<?php

if ( !class_exists('ph_shipping_rate_adjustment_settings') ) {

	class ph_shipping_rate_adjustment_settings extends WC_Settings_Page {

		public function __construct() {

			$this->id 		= 'ph_shipping_rate_adjustment';
			$this->label 	= __( 'Shipping Cost Adjustment', 'ph-wc-shipping-rate-adjustment' );

			add_filter( 'woocommerce_settings_tabs_array', array( $this, 'add_settings_page' ), 21 );

			add_action( 'woocommerce_settings_' . $this->id, array( $this, 'shipping_rate_adjustment_settings_output' ) );
			add_action( 'woocommerce_settings_save_' . $this->id, array( $this, 'shipping_rate_adjustment_settings_save' ) );

			add_action('woocommerce_admin_field_rate_adjustment',array( $this, 'generate_rate_adjustment_html'));

		}

		public function shipping_rate_adjustment_get_settings( $current_section = '' ) {

			global $current_section;

			switch($current_section) {

				case '':
				case 'ph_rate_adjustment':
				$settings = apply_filters( 'ph_shipping_rate_adjustment_settings', array(

					'rate_adjustment_options_title'	=>	array(
						'name'		=> __( 'Shipping Cost Adjustment', 'ph-wc-shipping-rate-adjustment' ),
						'type'		=> 'title',
						'desc'		=> '',
						'id'		=> 'ph_shipping_rate_adjustment_options_title',
					),
					'rate_adjustment'	=>	array(
						'type'		=> 'rate_adjustment',
						'id'		=> 'ph_shipping_rate_adjustment_rate_adjustment',
					),
					'rate_adjustment_options_sectionend' 	=>	array(
						'type'		=> 'sectionend',
						'id'		=> 'ph_shipping_rate_adjustment_options_sectionend'
					),

				) );

				break;
			}

			return apply_filters( 'woocommerce_get_settings_' . $this->id, $settings, $current_section );
		}

		public function shipping_rate_adjustment_settings_output() {

			global $current_section;

			$settings 	= $this->shipping_rate_adjustment_get_settings( $current_section );

			WC_Admin_Settings::output_fields( $settings );
		}

		public function shipping_rate_adjustment_settings_save() {

			global $current_section;

		    //Remove the array key for empty data
			if( ! empty($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section']) ) {

				foreach ($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section'] as $key => $value) {

					if( !empty($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section'][$key]) && ( empty($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section'][$key]['shipping_method']) && empty($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section'][$key]['shipping_method_id']) ) ) {

						unset($_POST['ph_shipping_rate_adjustment_rate_adjustment']['adjustment_section'][$key]);

					}
				}
			}

			$settings = $this->shipping_rate_adjustment_get_settings( $current_section );

			WC_Admin_Settings::save_fields( $settings );
		}

		public function generate_rate_adjustment_html() {

			include( 'html-shipping-rate-adjustment-options.php' );
		}

	}

	return new ph_shipping_rate_adjustment_settings();
}