<?php

$saved_matrix 		= get_option('ph_shipping_rate_adjustment_rate_adjustment');
$shipping_classes 	= array();
$shipping_methods	= array();

$and_logic 	= isset($saved_matrix['logic_section']) && isset($saved_matrix['logic_section']['and_logic']) ? $saved_matrix['logic_section']['and_logic'] : false;

if( class_exists('WC_Shipping') ) {

	$shipping_method_obj 	= new WC_Shipping;

	$shipping_classes 	= !empty( $shipping_method_obj->get_shipping_classes() ) ? $shipping_method_obj->get_shipping_classes() : array();

	$shipping_methods 	= !empty( $shipping_method_obj->get_shipping_methods() ) ? $shipping_method_obj->get_shipping_methods() : array();
}

?>
<div>

	<h4><?php _e('Instructions to use this plugin', 'ph-wc-shipping-rate-adjustment'); ?></h4>

	<ul style="margin-left: 45px !important;list-style-type: square !important;">
		<li><?php _e('Select a shipping class based on which you want to adjust the shipping cost', 'ph-wc-shipping-rate-adjustment'); ?></li>
		<li><?php _e('Select one option under Shipping Service if you want to adjust all the shipping methods under that service', 'ph-wc-shipping-rate-adjustment'); ?></li>
		<li><?php _e('Or, you can enter the value of a shipping method (s) under Shipping Method Value to adjust only that particular shipping method', 'ph-wc-shipping-rate-adjustment'); ?></li>
		<li><?php _e('Set Adjustment(%) or Adjustment($) as per your requirement', 'ph-wc-shipping-rate-adjustment'); ?></li>
	</ul>

</div>

<table style="width:70%">
	<tr>
		<td style="width:30%">
			<strong><?php _e('Shipping Class Combination', 'ph-wc-shipping-rate-adjustment' ); ?></strong>
		</td>

		<td >
			<?php
			woocommerce_form_field(
				"ph_shipping_rate_adjustment_rate_adjustment[logic_section][and_logic]", array(
					'id'		=> "and_logic",
					'type'		=> "checkbox",
					'label'		=> __("Enable","ph-wc-shipping-rate-adjustment"),
				),$and_logic
			); ?>   
		</td>
		
	</tr>
</table>

<table class="wp-list-table widefat fixed posts rate_rule_matrix" style="width:100%; margin-bottom:30px">

	<thead>
		<tr>
			<th><?php  _e('Shipping Class', 'ph-wc-shipping-rate-adjustment' ); ?></th>
			<th><?php  _e('Shipping Service', 'ph-wc-shipping-rate-adjustment'); ?></th>
			<th><?php  _e('Shipping Method Value', 'ph-wc-shipping-rate-adjustment'); ?></th>
			<th style="text-align: right;"><?php  _e('Cost Adjustment ('.get_woocommerce_currency_symbol().')', 'ph-wc-shipping-rate-adjustment'); ?></th>
			<th style="text-align: right;"><?php  _e('Cost Adjustment (%)', 'ph-wc-shipping-rate-adjustment'); ?></th>
		</tr>
	</thead>
	
	<tbody>
		<?php 
		
		$this->rate_rule_matrix = array();

		if( empty($saved_matrix) || empty($saved_matrix['adjustment_section']) ) {

			$this->rate_rule_matrix[0]['shipping_class'] 			= array();
			$this->rate_rule_matrix[0]['shipping_method']			= '';
			$this->rate_rule_matrix[0]['shipping_method_id']		= '';
			$this->rate_rule_matrix[0]['fixed_adjustment']			= null;
			$this->rate_rule_matrix[0]['percent_adjustment']		= null;

		} else {

			$id = 0;
			foreach ( $saved_matrix['adjustment_section'] as $matrix ) {

				$this->rate_rule_matrix[$id]['shipping_class']		= !empty($matrix['shipping_class']) ? $matrix['shipping_class']: array();
				$this->rate_rule_matrix[$id]['shipping_method']		= !empty($matrix['shipping_method']) ? $matrix['shipping_method'] : '';
				$this->rate_rule_matrix[$id]['shipping_method_id']	= !empty($matrix['shipping_method_id']) ? $matrix['shipping_method_id'] : '';
				$this->rate_rule_matrix[$id]['fixed_adjustment']	= !empty($matrix['fixed_adjustment']) ? $matrix['fixed_adjustment'] : '';
				$this->rate_rule_matrix[$id]['percent_adjustment']	= !empty($matrix['percent_adjustment']) ? $matrix['percent_adjustment'] : '';

				$id++;
			}
		}

		foreach ( $this->rate_rule_matrix as $key => $value ) {

			global $woocommerce;

			if ( !array_filter($value) ) {
				continue;
			}

			?>
			<tr>

				<!-- Shipping Class -->
				<td>    
					<?php
					if( !empty($shipping_classes) ) {

						?>
						<select name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_class][]" class="wc-enhanced-select" multiple="multiple" style="width: 70%">
							<?php
							foreach ($shipping_classes as $id => $shipping_class) {

								if( in_array( $shipping_class->slug, $this->rate_rule_matrix[ $key ]['shipping_class'] ) ) {

									echo"<option value='$shipping_class->slug' selected>$shipping_class->name</option>";
								}else{

									echo"<option value='$shipping_class->slug'>$shipping_class->name</option>";
								}
							}
							?>
						</select>
						<?php
					}
					?>
				</td>

				<!-- Shipping Methods -->
				<td>    
					<?php
					if( !empty($shipping_methods) ) {

						?>
						<select name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_method]" style="width: 70%">
							<?php

							echo "<option value=''>Select</option>";

							foreach ($shipping_methods as $method_id => $method_data) {

								if( $this->rate_rule_matrix[ $key ]['shipping_method'] == $method_id ) {

									echo"<option value='$method_id' selected>$method_data->method_title</option>";
								}else{

									echo"<option value='$method_id'>$method_data->method_title</option>";
								}
							}
							?>
						</select>
						<?php
					}
					?>
				</td>

				<!-- Method Value -->
				<td >
					<textarea placeholder="free_shipping:1;flat_rate:2;" style="width:100%" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_method_id]"><?php  echo isset( $this->rate_rule_matrix[ $key ]['shipping_method_id'] ) ? $this->rate_rule_matrix[ $key ]['shipping_method_id'] : ''; ?></textarea>
				</td>

				<!-- Fixed Adjustment -->
				<td style="text-align: right;">
					<input type="number" step="any" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][fixed_adjustment]" value="<?php  echo isset( $this->rate_rule_matrix[ $key ]['fixed_adjustment'] ) ? $this->rate_rule_matrix[ $key ]['fixed_adjustment'] : ''; ?>" style="width: 50%"/>
				</td>

				<!-- Percentage Adjustment -->
				<td style="text-align: right;">
					<input type="number" step="any" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][percent_adjustment]" value="<?php  echo isset( $this->rate_rule_matrix[ $key ]['percent_adjustment'] ) ? $this->rate_rule_matrix[ $key ]['percent_adjustment'] : ''; ?>" style="width: 50%"/>
				</td>

			</tr>
			<?php 
		}
		?>

		<tr>
			<td>
				<?php

				$key = !isset($key) ? 0 : $key+1;

				if ( !empty($shipping_classes) ) {
					?>

					<select name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_class][]" class="wc-enhanced-select" multiple="multiple" style="width: 70%">
						<?php

						foreach ($shipping_classes as $id => $shipping_class) {
							echo"<option value=".$shipping_class->slug.">$shipping_class->name</option>";
						}
						?>
					</select>
					<?php
				}
				?>
			</td>

			<td>    
				<?php

				if ( !empty($shipping_methods) ) {
					?>

					<select name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_method]" style="width: 70%">
						<?php

						echo "<option value=''>Select</option>";

						foreach ($shipping_methods as $method_id => $shipping_method) {
							echo"<option value=".$method_id.">$shipping_method->method_title</option>";
						}
						?>
					</select>
					<?php
				}
				?>
			</td>

			<td >
				<textarea placeholder="free_shipping:1;flat_rate:2;" style="width:100%" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][shipping_method_id]"></textarea>
			</td>

			<td style="text-align: right;">
				<input type="number" step="any" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][fixed_adjustment]" style="width: 50%"/>
			</td>
			
			<td style="text-align: right;">
				<input type="number" step="any" name="ph_shipping_rate_adjustment_rate_adjustment[adjustment_section][<?php  echo $key; ?>][percent_adjustment]" style="width: 50%"/>
			</td>

		</tr>
	</tbody>
</table>